/* ppcm.y
 parseur de ppcm : le code est genere au fur et a mesure du parsing
 */
%{
# include <stdio.h>

char * chainop;                 /* assembleur pour l'operateur courant */
int posexpr, incr;              /* deplacement ds la pile pour les variables */
char * fonction;                /* le nom de la fonction courante */

# include "ppcm.h"

# define YYDEBUG 1

// Declaration des fonctions utilisées dans la grammaire
int yylex(void);
void yyerror(char *);
int label();
void nomem();
%}

%union {
  int i;                        /* constantes, etiquettes et nbre d'arg. */
  char * c;                     /* variables et fonctions */
  struct expr *  e;             /* expressions */
};

%token <c> YNOM
%token <i> YNUM
%token YINT YIF YELSE YWHILE YRETURN

%type <i> ifdebut .listexpr
%type <e> expr

%right '='
%nonassoc YNEQ
%left '+' '-'
%left '*' '/' '%'
%left FORT

%%
programme : /* rien */          /* point d'entree : rien que des fonctions */
        | programme fonction
        ;

.listinstr : /* rien */         /* liste d'instructions */
        | .listinstr instr
        ;

fonction
        : YNOM '('
                { posexpr = 8; incr = 4; }
          .listarg ')' '{'
                { posexpr = -4; incr = -4; }
          .listvar
                { printf(".text\n\t.align 16\n.globl %s\n", $1);
                  printf("deb%s:\n", $1);
                  fonction = $1;
                }
          .listinstr '}'
                {               /* epilogue */
                  printf("fin%s:\n", $1);
                  printf("\tmovl %%ebp,%%esp\n\tpopl %%ebp\n\tret\n");
                                /* proloque */
                  printf("%s:\n", $1);
                  printf("\tpushl %%ebp\n\tmovl %%esp,%%ebp\n");
                  printf("\tsubl $%d,%%esp\n", -posexpr-4);
                  printf("\tjmp deb%s\n", $1);

                  reinitexpr();
                }
        ;
                                /* liste des arguments a fournir a l'appel */
.listarg : /* rien */
        |  listnom
        ;
                                /* liste des variables de la fonction */
.listvar : /* rien */
        | YINT  listnom ';'
        ;
                               /* la liste des noms : arguments ou variables */
listnom : YNOM
                { fairexpr($1); }
        | listnom ',' YNOM
                { fairexpr($3); }
        ;

instr   : ';'                   /* Toutes les instructions */
        | '{' .listinstr '}'
        | expr ';'
                { ; }
        | ifdebut instr
                { printf("else%d:\n", $1); }
        | ifdebut instr YELSE
                { printf("\tjmp fin%d\n", $1);
                  printf("else%d:\n", $1);
                }
          instr
                { printf("fin%d:\n", $1); }
        | YWHILE '('
                { printf("debut%d:\n", $<i>$ = label()); }
          expr ')'
                { printf("\tcmpl $0,%d(%%ebp)\n", $4->position);
                  printf("\tje fin%d\n", $<i>3); }
          instr
                { printf("\tjmp debut%d\n", $<i>3);
                  printf("fin%d:\n", $<i>3);
                }
        | YRETURN expr ';'
                { printf("\tmovl %d(%%ebp),%%eax\n", $2->position);
                  printf("\tjmp fin%s\n", fonction);
                }
        ;

ifdebut : YIF '(' expr ')'
                { printf("\tcmpl $0,%d(%%ebp)\n", $3->position);
                  printf("\tje else%d\n", $$ = label());
                }
        ;
                                /* toutes les expressions */
expr    : YNOM
                { $$ = exprvar($1); }
        | '(' expr ')'
                { $$ = $2; }
        | YNUM
                { $$ = fairexpr(NULL);
                  printf("\tmovl $%d,%d(%%ebp)\n", $1, $$->position);
                }
        | YNOM '=' expr
                { printf("\tmovl %d(%%ebp),%%eax\n", $3->position);
                  printf("\tmovl %%eax,%d(%%ebp)\n", exprvar($1)->position);
                  $$ = $3;
                }
        | '-' expr %prec FORT
                { printf("\tmovl %d(%%ebp),%%eax\n", $2->position);
                  printf("\tnegl %%eax\n");
                  $$ = fairexpr(NULL);
                  printf("\tmovl %%eax,%d(%%ebp)\n", $$->position);
                }
        | expr '-' expr
                { chainop = "subl";
                bin:
                  printf("\tmovl %d(%%ebp),%%eax\n", $1->position);
                  printf("\t%s\t%d(%%ebp),%%eax\n", chainop, $3->position);
                  $$ = fairexpr(NULL);
                  printf("\tmovl %%eax,%d(%%ebp)\n", $$->position);
                }
        | expr '+' expr
                { chainop = "addl"; goto bin; }
        | expr '*' expr
                { chainop = "imull"; goto bin; }
        | expr YNEQ expr
                { chainop = "subl"; goto bin; } 
        | expr '/' expr
                { chainop = "%eax";
             div: printf("\tmovl %d(%%ebp),%%eax\n\tcltd\n", $1->position);
                  printf("\tidivl\t%d(%%ebp),%%eax\n", $3->position);
                  $$ = fairexpr(NULL);
                  printf("\tmovl %s,%d(%%ebp)\n", chainop, $$->position);
                }
        | expr '%' expr
                { chainop = "%edx"; goto div; }
        | YNOM '(' .listexpr ')'
                { printf("\tcall %s\n", $1);
                  if ($3 != 0)
                    printf("\taddl $%d,%%esp\n", $3 * 4);
                  $$ = fairexpr(NULL);
                  printf("\tmovl %%eax,%d(%%ebp)\n", $$->position);
                }
        ;
                                /* liste d'expressions (appel de fonction) */
.listexpr : /* rien */
                { $$ = 0; }
        | expr
                { $$ = 1; printf("\tpushl %d(%%ebp)\n", $1->position); }
        | expr ',' .listexpr
                { $$ = $3 + 1; printf("\tpush %d(%%ebp)\n", $1->position); }
        ;
%%
int
main(){
  yyparse();
  return 0;
}

/* label  -- renvoie un nouveau numero d'etiquette a chaque appel */
int label(){ // On ajoute explicitement le type de la valeur de retour
  static int foo = 0;
  return foo++;
}

# include "lex.yy.c"            /* yylex et sa clique */

void yyerror(char * message){ // On ajoute explicitement le type de la valeur de retour
  extern int lineno;
  extern char * yytext;

  fprintf(stderr, "%d: %s at %s\n", lineno, message, yytext);
}

void nomem(){ // On ajoute explicitement le type de la valeur de retour
  fprintf(stderr, "Pas assez de memoire\n");
  exit(1);
}
